# FullTcp sample
# simple network model
#
#  1 ========== 0
#       384K
#       500ms
#

if {$argc == 3} {
    set droplist [lindex $argv 0]
    set outlog [lindex $argv 1]
    set sender [lindex $argv 2]
} else {
    puts "ns test.tcl droplist outlog"
    exit 1
}


set ns [new Simulator]

Trace set show_tcphdr_ 2

set f [open $outlog w]
$ns trace-all $f

#set nf [open out.nam w]
#$ns namtrace-all $nf

proc finish {} {
    global ns f #nf
    $ns flush-trace
    close $f
    #close $nf
    exit 0
}

if {$sender == "Sack1"} {
	set tcpsender "FullTcp/Sack"
	set receiver "FullTcp/Sack"
} else {
	if {$sender == "Reno"} {
		set tcpsender "FullTcp"
		set receiver "FullTcp"
	} else {
		if {$sender == "Tahoe"} {
			set tcpsender "FullTcp/Tahoe"
			set receiver "FullTcp/Tahoe"
		}
	}
}

set n0 [$ns node]
set n1 [$ns node]

$ns duplex-link $n0 $n1 384Kb 500ms DropTail
$ns duplex-link-op $n0 $n1 orient right-up
$ns duplex-link-op $n0 $n1 queuePos 0.5
$ns queue-limit $n0 $n1 30

set em [new ErrorModel/List]
$em unit pkt
$em droplist $droplist
$ns link-lossmodel $em $n0 $n1

set src [new Agent/TCP/$tcpsender]
set sink [new Agent/TCP/$receiver]
$ns attach-agent $n0 $src
$ns attach-agent $n1 $sink
$src set fid_ 0
$sink set fid_ 0
$ns connect $src $sink

$src set segsize_ 1460
$src set window_ [expr 65535 / 1460]
$src set windowInit_ 1

$sink set segsize_ 1460
$sink set segsperack_ 2
$sink set interval_ 0.2
$sink listen

set ftp [new Application/FTP]
$ftp attach-agent $src
$ns at 0 "$ftp start"

$ns at 30 "finish"
$ns run
