# simple WCDMA network model
#
#       64k->      384k      1.5M
#       500ms      1ms       1ms
#  3 ========== 2 ======= 1 ======= 0
#     <-364.8k
#       500ms
#

set ns [new Simulator]
Trace set show_tcphdr_ 2

$ns color 0 Black
$ns color 1 Brown
$ns color 2 Red
$ns color 3 Orange
$ns color 4 Yellow
$ns color 5 Green
$ns color 6 Blue
$ns color 7 Purple

set f [open out.tr w]
$ns trace-all $f

#set nf [open out.nam w]
#$ns namtrace-all $nf

proc finish {} {
    global ns f nf
    $ns flush-trace
    close $f
    #close $nf
    exit 0
}


set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]

$ns duplex-link $n0 $n1 1.5Mb 1ms DropTail
$ns duplex-link-op $n0 $n1 orient right-up
$ns duplex-link-op $n0 $n1 queuePos 0.5
$ns queue-limit $n0 $n1 50

$ns duplex-link $n1 $n2 384Kb 1ms DropTail
$ns duplex-link-op $n1 $n2 orient right-up
$ns duplex-link-op $n1 $n2 queuePos 0.5
$ns queue-limit $n1 $n2 50

$ns simplex-link $n2 $n3 364.8Kb 500ms DropTail
$ns simplex-link-op $n2 $n3 orient right-up
$ns simplex-link-op $n2 $n3 queuePos 0.5
$ns queue-limit $n2 $n3 10

$ns simplex-link $n3 $n2 64Kb 500ms DropTail
$ns simplex-link-op $n3 $n2 orient left-down
$ns simplex-link-op $n3 $n2 queuePos 0.5
$ns queue-limit $n3 $n2 50


set tcp1 [new Agent/TCP/Sack1]
$ns attach-agent $n0 $tcp1
$tcp1 set packetSize_ 1460
$tcp1 set window_ [expr 65535 / 1460]
$tcp1 set bugFix_ false
$tcp1 set fid_ 0
set sink1 [new Agent/TCPSink/Sack1/DelAck]
$ns attach-agent $n3 $sink1
$ns connect $tcp1 $sink1
set ftp1 [new Application/FTP]
$ftp1 attach-agent $tcp1
$ns at 0 "$ftp1 start"


$ns at 60 "finish"
$ns run
